;;; Lisplab, matliap/tridiag.lisp
;;; Lapack-based, tridiagonal routines

;;; Copyright (C) 2009 Joern Inge Vestgaarden
;;;
;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License along
;;; with this program; if not, write to the Free Software Foundation, Inc.,
;;; 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

(in-package :lisplab)

(defmethod lin-solve ((A matrix-lisp-dgt) (b matrix-blas-dge))
  (lin-solve! (copy A) (copy b)))

(defmethod lin-solve! ((A matrix-lisp-dgt) (b matrix-blas-dge))
  ;; TODO catch error from input
  (if cl-user::*lisplab-liblapack-path*
      (let* ((N (cols A)))
	(f77::dgtsv N 
		    1 
		    (slot-value a 'subdiagonal-store ) 
		    (slot-value a 'diagonal-store)
		    (slot-value a 'superdiagonal-store)
		    (matrix-store b)
		    N
		    0)
	b)
      (call-next-method)))