;;; Lisplab, level1-dge.lisp
;;; General, storeless matrices

;;; Copyright (C) 2009 Joern Inge Vestgaarden
;;;
;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License along
;;; with this program; if not, write to the Free Software Foundation, Inc.,
;;; 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

(in-package :lisplab)

;;; Function matrices (matrices without a store)

(defclass function-matrix
    (matrix-structure-general matrix-element-base matrix-implementation-base)
  ((mref
    :initarg :mref
    :initform (constantly 0)
    :accessor function-matrix-mref
    :type function)
   (set-mref
    :initarg :set-mref
    :initform (constantly nil)
    :accessor function-matrix-set-mref
    :type function)
   (vref
    :initarg :vref
    :initform (constantly 0)
    :accessor function-matrix-vref 
    :type function)
   (set-vref
    :initarg :set-vref
    :initform (constantly nil)
    :accessor function-matrix-set-vref
    :type function))
  (:documentation "Matrix without a store."))

(defmethod initialize-instance :after ((m function-matrix) &key)
  (with-slots (rows cols size matrix-store) m
    (setf size (* rows cols))))

;;; Level1 methods specialized for the function matrix

(defmethod mref ((f function-matrix) row col)
  (funcall (function-matrix-mref f) f row col))

(defmethod (setf mref) (value (f function-matrix) row col)
  (funcall (function-matrix-set-mref f) value f row col))

(defmethod vref ((f function-matrix) idx)
  (funcall (function-matrix-vref f) f idx))

(defmethod (setf vref) (value (f function-matrix) idx)
  (funcall (function-matrix-set-vref f) value f idx))
