;;; Lisplab, level1-matrix.lisp
;;; Level1, matrix basic methods
;;; 

;;; Copyright (C) 2009 Joern Inge Vestgaarden
;;;
;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License along
;;; with this program; if not, write to the Free Software Foundation, Inc.,
;;; 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

;;; Note: use the slot-value rather than the methods, since slot-value is faster.

;;; TODO: clean up

(in-package :lisplab)

(defmethod vector-p ((x matrix-base)) t)

(defmethod matrix-p ((x matrix-base)) t)

(defmethod rank ((matrix matrix-base)) 2)

(defmethod dim ((matrix matrix-base) &optional direction)
  (if direction
      (ecase direction 
	(0 (rows matrix))
	(1 (cols matrix)))
      (list (rows matrix) (cols matrix))))

(defmethod print-object ((matrix matrix-base) stream)
  "Prints matrix as an unreadable object. The number of printed
rows and columns is limited by *lisplab-print-size*."
  (print-unreadable-object (matrix stream :type t :identity t)
    (let ((rows (min (rows matrix) *lisplab-print-size*))
	  (cols (min (cols matrix) *lisplab-print-size*)))
      (format stream " ~ax~a~&" (rows matrix) (cols matrix)) 
      (dotimes (i rows)
	(dotimes (j cols)
	  (format stream "~a " (mref matrix i j)))
	(when (< cols (cols matrix))
	  (format stream "..."))
	(princ #\Newline stream))
      (when (< rows (rows matrix))
	(format stream "...~%")))))

;;; Spezialized for square matrices

(defmethod rows ((matrix matrix-structure-square))
  (slot-value matrix 'rowcols))

(defmethod cols ((matrix matrix-structure-square))
  (slot-value matrix 'rowcols))




