;;; Permutation.lisp 
;;; Permutation of matrix indices. 

;;; Copyright (C) 2009 Joern Inge Vestgaarden
;;;
;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License along
;;; with this program; if not, write to the Free Software Foundation, Inc.,
;;; 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

(in-package :lisplab)

(deftype type-permutation ()  
  ;; This should be the same as the max size of arrays
  'type-blas-idx)

(deftype type-permutation-vector ()
  '(simple-array type-permutation (*)))

(defun make-permutation-vector (n)
  (let ((a (make-array n :element-type 'type-permutation)))
    (declare (type-permutation-vector a))
    (dotimes (i n)
      (setf (aref a i) i))
    a))

(defun invert-permutation (p)
  (let* ((n (length p))
	 (ip (make-array n :element-type 'type-permutation)))
    (declare (type-permutation-vector ip))
    (dotimes (i n)
      (setf (aref ip (aref p i)) i))
    ip))