;;; Lisplab, level3-euler.lisp
;;; Eules method for solving differential equations.

;;; Copyright (C) 2009 Joern Inge Vestgaarden
;;;
;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License along
;;; with this program; if not, write to the Free Software Foundation, Inc.,
;;; 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

(in-package :lisplab)

(defun euler (func y x 
	      &key 
	      (step)
	      (update)
	      (test (constantly nil)))
  "The Euler solution of differential equations"
  (do* ((h (funcall step y x) (funcall step y x)))
       ((not (funcall test y x)) (values y x))
    (setf y (.+ y (.* h (funcall func y x)))
	  x (+ x h))
    (when update
      (funcall update y x))))
